routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});
Auth::routes(['register' => false]);
Route::group(['middleware' => 'admin'], function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('/company','CompanyController');
    Route::get('/companyDatatable','CompanyDatatable')->name('companyDatatable');
    Route::resource('/employee','EmployeeController');
    Route::get('/employeeDatatable','EmployeeDatatable')->name('employeeDatatable');
});

app/Employee.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Employee extends Model
{
    protected $table = 'employees';

    public function company(){
        return $this->belongsTo(Company::class);
    }
    public function images()
    {
        return $this->morphOne(Image::class ,'imageable', 'model_type', 'model_id');
    }

}

app/Http/Controllers/Api/v1/EmployeeController.php
<?php

namespace App\Http\Controllers\Api\v1;

use App\Company;
use App\Employee;
use App\Http\Controllers\Controller;
use App\Http\Requests\EmployeeRequest;
use App\Http\Resources\EmployeeResources;
use App\Image;
use Illuminate\Http\Request;

class EmployeeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        try{
            $page = ($request->has("page") ?$request->page : 1)  ;
            $company = Employee::paginate(5, ['*'], 'page', $page);
            return EmployeeResources::collection($company);

        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while show all Employees '
            ]);

        }
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(EmployeeRequest $request)
    {
        try {

            //create Main Company Data
            $employee = new Employee();
            $employee->name = $request->name;
            $employee->company_id = $request->company_id;
            $employee->save();

            //upload company image
            $imageName = time() . '.' . request()->image->getClientOriginalExtension();
            request()->image->move(public_path('images'), $imageName);

            // add image to company model
            $imageable = new Image();
            $imageable->image_path = $imageName;
            $imageable->model_id = $employee->id;
            $imageable->model_type = 'App\Employee';
            $employee->images()->save($imageable);
            return new EmployeeResources(Employee::find($employee->id));
        }catch (\Exception $e){
            return response()->json([
                'error' => 'There is error while Update Employee '
            ]);

        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        try{
            return new EmployeeResources(Employee::find($id));
        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while show employee'
            ]);
        }

    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try{
            $request->validate([
                'image' => 'image|mimes:jpeg,png,jpg|max:2048',
            ]);
            $employee =  Employee::findOrFail($id);
            if($request->has('name')){
                $employee->name = $request->name;
            }
            if($request->has('company_id')){
                $employee->company_id = $request->company_id;
            }
            $employee->save();
            if($request->hasfile('image')){
                //upload company image
                $imageName = time().'.'.request()->image->getClientOriginalExtension();
                request()->image->move(public_path('images'), $imageName);

                // add image to company model
                Image::where(['model_id'=>$id,'model_type'=>'App\Employee'])
                    ->update(['image_path'=>$imageName]);
            }
            return new EmployeeResources(Employee::find($id));
        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while show employee'
            ]);
        }


    }
    public function destroy($id)
    {
        try{
            Employee::destroy($id);
            return response()->json([
                'message' => 'Successfully deleted Company!'
            ]);

        }catch(\Exception $e){
            return response()->json([
                'error' => 'There is error while delete company'
            ]);

        }

    }

}

app/Http/Controllers/EmployeeController.php
<?php

namespace App\Http\Controllers;

use App\Company;
use App\Employee;
use App\Http\Requests\EmployeeRequest;
use App\Image;
use Illuminate\Http\Request;

class EmployeeController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('employee.datatable');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $company = Company::all();
        return view('employee.create',compact('company'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(EmployeeRequest $request)
    {
        //create Main Company Data
        $employee = new Employee();
        $employee->name = $request->name;
        $employee->company_id = $request->company_id;
        $employee->save();

        //upload company image
        $imageName = time().'.'.request()->image->getClientOriginalExtension();
        request()->image->move(public_path('images'), $imageName);

        // add image to company model
        $imageable = new Image();
        $imageable->image_path = $imageName;
        $imageable->model_id = $employee->id;
        $imageable->model_type = 'App\Employee';
        $employee->images()->save($imageable);
        return redirect()->route('employee.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $employee = Employee::findOrFail($id);
        $company = Company::all();
        return view('employee.edit',compact('company','employee'));

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'image' => 'image|mimes:jpeg,png,jpg|max:2048',
            'name' => 'required'
        ]);
        $employee =  Employee::findOrFail($id);
        $employee->name = $request->name;
        $employee->company_id = $request->company_id;
        $employee->save();

        if($request->hasfile('image')){
            //upload company image
            $imageName = time().'.'.request()->image->getClientOriginalExtension();
            request()->image->move(public_path('images'), $imageName);

            // add image to company model
            Image::where(['model_id'=>$id,'model_type'=>'App\Employee'])
                ->update(['image_path'=>$imageName]);
        }
        return redirect()->route('employee.index');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Employee::destroy($id);
        return redirect()->route('employee.index');

    }
}

resources/views/employee/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-10 col-md-offset-1">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="col-md-4">
                                <h3>Create Employee</h3>
                            </div>
                        </div>
                    </div>
                    <br>
                    @if (count($errors) > 0)

                        <div class="alert alert-danger">

                            <strong>Whoops!</strong> There were some problems with your input.

                            <ul>

                                @foreach ($errors->all() as $error)

                                    <li>{{ $error }}</li>

                                @endforeach

                            </ul>

                        </div>

                    @endif

                    <div class="panel-body">
                        <form action="{{route('employee.store')}}" method="post" enctype="multipart/form-data">
                            {{csrf_field()}}
                            <div class="form-group">
                                <label for="exampleInput1">Employee Name</label>
                                <input type="text" name="name" class="form-control" id="exampleInput1"  placeholder="Enter Company Name" required>
                            </div>
                            <div class="form-group">
                                <label for="exampleInput1">Company Name</label>
                                <select name="company_id" class="form-control">
                                    <option value="" selected>Select Your Company</option>
                                    @foreach($company as $com)
                                        <option value="{{$com->id}}">{{$com->name}}</option>
                                        @endforeach
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="exampleFormControlFile1">Image file input</label>
                                <input type="file" name="image" class="form-control-file" id="exampleFormControlFile1" required>
                            </div>
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/employee/datatable.blade.php
@extends('layouts.app')
@section('style')
    <link href="https://cdn.datatables.net/1.10.12/css/jquery.dataTables.min.css" rel="stylesheet">
@endsection
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-10 col-md-offset-1">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="col-md-4">
                                <h3>Employee Datatable</h3>
                            </div>
                            <div class="col-md-4">
                                <a href="{{route('employee.create')}}" class="btn btn-dark" >Create Employee</a>
                            </div>
                        </div>
                    </div>

                    <div class="panel-body">
                        <table class="table table-hover table-bordered table-striped datatable" style="width:100%">
                            <thead>
                            <tr>
                                <th>Id</th>
                                <th>Name</th>
                                <th>Company Name</th>
                                <th>image</th>
                                <th>action</th>
                            </tr>
                            </thead>
                        </table>
                    </div>
                </div>
            </div>
        </div>    </div>
@endsection
@section('script')
    <script src="https://cdn.datatables.net/1.10.12/js/jquery.dataTables.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $.noConflict();
            console.log('test')
            $('.datatable').DataTable({
                processing: true,
                serverSide: true,
                ajax: '{{ route('employeeDatatable') }}',
                columns: [
                    {data: 'id', name: 'id'},
                    {data: 'name', name: 'name'},
                    {data: 'company', name: 'company'},
                    {data: 'images', name: 'images',orderable: false, searchable:false },
                    {data: 'action', name: 'action',orderable: false, searchable:false },
                ]
            });
        });
    </script>
@endsection

resources/views/employee/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-10 col-md-offset-1">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <div class="row">
                            <div class="col-md-4">
                                <h3>Update Employee</h3>
                            </div>
                        </div>
                    </div>
                    <br>
                    @if (count($errors) > 0)

                        <div class="alert alert-danger">

                            <strong>Whoops!</strong> There were some problems with your input.

                            <ul>

                                @foreach ($errors->all() as $error)

                                    <li>{{ $error }}</li>

                                @endforeach

                            </ul>

                        </div>

                    @endif

                    <div class="panel-body">
                        <form action="{{route('employee.update',[$employee->id])}}" method="post" enctype="multipart/form-data">
                            {{ method_field('PATCH') }}
                            {{csrf_field()}}
                            <div class="form-group">
                                <label for="exampleInput1">Employee Name</label>
                                <input type="text" name="name" class="form-control" id="exampleInput1" value="{{$employee->name}}" placeholder="Enter Company Name" required>
                            </div>
                            <div class="form-group">
                                <label for="exampleInput1">Company Name</label>
                                <select name="company_id" class="form-control">
                                    @foreach($company as $com)

                                        <option
                                                @if($employee->company_id == $com->id) selected @endif
                                                value="{{$com->id}}">
                                                    {{$com->name}}
                                        </option>
                                    @endforeach
                                </select>
                            </div>
                            <div class="form-group">
                                <label for="exampleFormControlFile1">Image file input</label>
                                <input type="file" name="image" class="form-control-file" id="exampleFormControlFile1">
                                <img src="{{asset('/images/'.$employee->images->image_path)}}" alt="" width="150" height="150">

                            </div>
                            <button type="submit" class="btn btn-primary">Submit</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection